unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TF_Main = class(TForm)
    B_Start: TButton;
    M_Output: TMemo;
    B_Stop: TButton;
    procedure B_StartClick(Sender: TObject);
    procedure B_StopClick(Sender: TObject);
  private
    { Private declarations }
    LV_Stop : Boolean;
  public
    { Public declarations }
  end;

var
  F_Main: TF_Main;

implementation

{$R *.dfm}

procedure TF_Main.B_StartClick(Sender: TObject);
var Player1Door    : LongInt;
    Player2Door    : LongInt;
    Player1Score   : LongInt;
    Player2Score   : LongInt;
    Player1Door1   : LongInt;
    Player1Door2   : LongInt;
    Player1Door3   : LongInt;
    Player2Door1   : LongInt;
    Player2Door2   : LongInt;
    Player2Door3   : LongInt;
    Door           : LongInt;
    Door1          : LongInt;
    Door2          : LongInt;
    Door3          : LongInt;
    i              : LongInt;
    UpdateOutput   : Boolean;
    ProcessingTime : LongInt;
begin
  LV_Stop := False;
  Randomize;
  Player1Score := 0;
  Player2Score := 0;
  Player1Door1  := 0;
  Player1Door2  := 0;
  Player1Door3  := 0;
  Player2Door1  := 0;
  Player2Door2  := 0;
  Player2Door3  := 0;
  Door1         := 0;
  Door2         := 0;
  Door3         := 0;
  ProcessingTime := GetTickCount;
  for i := 1 to 1000000000 do
    begin
      if LV_Stop then break;
      UpdateOutput := False;
      Door := Random(3) + 1;
      Player1Door := Random(3) + 1;
      Player2Door := Player1Door;
      case Player1Door of
          1 : if Door = 2 then Player2Door := 2
                         else Player2Door := 3;
          2 : if Door = 3 then Player2Door := 3
                         else Player2Door := 1;
          3 : if Door = 1 then Player2Door := 1
                         else Player2Door := 2;
        end;
      if Player1Door = Door then inc(Player1Score);
      if Player2Door = Door then inc(Player2Score);
      if Player1Door = 1 then inc(Player1Door1);
      if Player1Door = 2 then inc(Player1Door2);
      if Player1Door = 3 then inc(Player1Door3);
      if Player2Door = 1 then inc(Player2Door1);
      if Player2Door = 2 then inc(Player2Door2);
      if Player2Door = 3 then inc(Player2Door3);
      if Door = 1 then inc(Door1);
      if Door = 2 then inc(Door2);
      if Door = 3 then inc(Door3);
      if i < 101 then UpdateOutput := True;
      if (i < 1001) and (i mod 10 = 0) then UpdateOutput := True;
      if (i < 10001) and (i mod 100 = 0) then UpdateOutput := True;
      if (i < 100001) and (i mod 1000 = 0) then UpdateOutput := True;
      if (i < 1000001) and (i mod 10000 = 0) then UpdateOutput := True;
      if (i < 10000001) and (i mod 100000 = 0) then UpdateOutput := True;
      if (i < 100000001) and (i mod 1000000 = 0) then UpdateOutput := True;
      if (i > 100000000) and (i mod 10000000 = 0) then UpdateOutput := True;
      if UpdateOutput then
        begin
          M_Output.Clear;
          M_Output.Lines.Add('');
          M_Output.Lines.Add(' Attempt               : ' + IntToStr(i) + ' - ' + FloatToStr(trunc((100/1000000000)*i*100)/100) + '%');
          M_Output.Lines.Add('');
          M_Output.Lines.Add(' Player 1 has won      : ' + IntToStr(Player1Score) + ' times - ' + FloatToStr(trunc((100/i)*Player1Score*100)/100) + '%');
          M_Output.Lines.Add(' Player 2 has won      : ' + IntToStr(Player2Score) + ' times - ' + FloatToStr(trunc((100/i)*Player2Score*100)/100) + '%');
          M_Output.Lines.Add('');
          M_Output.Lines.Add(' Prize behind door 1   : ' + IntToStr(Door1) + ' times - ' + FloatToStr(trunc((100/i)*Door1*100)/100) + '%');
          M_Output.Lines.Add(' Prize behind door 2   : ' + IntToStr(Door2) + ' times - ' + FloatToStr(trunc((100/i)*Door2*100)/100) + '%');
          M_Output.Lines.Add(' Prize behind door 3   : ' + IntToStr(Door3) + ' times - ' + FloatToStr(trunc((100/i)*Door3*100)/100) + '%');
          M_Output.Lines.Add('');
          M_Output.Lines.Add(' Player 1 picked door 1: ' + IntToStr(Player1Door1) + ' times - ' + FloatToStr(trunc((100/i)*Player1Door1*100)/100) + '%');
          M_Output.Lines.Add(' Player 1 picked door 2: ' + IntToStr(Player1Door2) + ' times - ' + FloatToStr(trunc((100/i)*Player1Door2*100)/100) + '%');
          M_Output.Lines.Add(' Player 1 picked door 3: ' + IntToStr(Player1Door3) + ' times - ' + FloatToStr(trunc((100/i)*Player1Door3*100)/100) + '%');
          M_Output.Lines.Add('');
          M_Output.Lines.Add(' Player 2 picked door 1: ' + IntToStr(Player2Door1) + ' times - ' + FloatToStr(trunc((100/i)*Player2Door1*100)/100) + '%');
          M_Output.Lines.Add(' Player 2 picked door 2: ' + IntToStr(Player2Door2) + ' times - ' + FloatToStr(trunc((100/i)*Player2Door2*100)/100) + '%');
          M_Output.Lines.Add(' Player 2 picked door 3: ' + IntToStr(Player2Door3) + ' times - ' + FloatToStr(trunc((100/i)*Player2Door3*100)/100) + '%');
          Application.ProcessMessages;
        end;
    end;
  ProcessingTime := GetTickCount - ProcessingTime;
  M_Output.Lines.Add('');
  M_Output.Lines.Add(' Systemperformance vs. 3GHz INTeL: ' + FloatToStr(trunc((1/ProcessingTime)*79594*100)/100));
end;

procedure TF_Main.B_StopClick(Sender: TObject);
begin
  LV_Stop := True;
end;

end.
